#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 17 "gram.y"
#include <config.h>
#include <includes.h>
#include <radvd.h>
#include <defaults.h>

extern struct Interface *IfaceList;
struct Interface *iface = NULL;
struct AdvPrefix *prefix = NULL;
struct AdvRoute *route = NULL;
struct AdvRDNSS *rdnss = NULL;

extern char *conf_file;
extern int num_lines;
extern char *yytext;
extern int sock;

static void cleanup(void);
static void yyerror(char *msg);

#if 0 /* no longer necessary? */
#ifndef HAVE_IN6_ADDR_S6_ADDR
# ifdef __FreeBSD__
#  define s6_addr32 __u6_addr.__u6_addr32
#  define s6_addr16 __u6_addr.__u6_addr16
# endif
#endif
#endif

#define ABORT	do { cleanup(); YYABORT; } while (0);

#line 112 "gram.y"
typedef union {
	unsigned int		num;
	int			snum;
	double			dec;
	struct in6_addr		*addr;
	char			*str;
	struct AdvPrefix	*pinfo;
	struct AdvRoute		*rinfo;
	struct AdvRDNSS		*rdnssinfo;
	struct Clients		*ainfo;
} YYSTYPE;
#line 66 "gram.c"
#define T_INTERFACE 257
#define T_PREFIX 258
#define T_ROUTE 259
#define T_RDNSS 260
#define T_CLIENTS 261
#define STRING 262
#define NUMBER 263
#define SIGNEDNUMBER 264
#define DECIMAL 265
#define SWITCH 266
#define IPV6ADDR 267
#define INFINITY 268
#define T_IgnoreIfMissing 269
#define T_AdvSendAdvert 270
#define T_MaxRtrAdvInterval 271
#define T_MinRtrAdvInterval 272
#define T_MinDelayBetweenRAs 273
#define T_AdvManagedFlag 274
#define T_AdvOtherConfigFlag 275
#define T_AdvLinkMTU 276
#define T_AdvReachableTime 277
#define T_AdvRetransTimer 278
#define T_AdvCurHopLimit 279
#define T_AdvDefaultLifetime 280
#define T_AdvDefaultPreference 281
#define T_AdvSourceLLAddress 282
#define T_AdvOnLink 283
#define T_AdvAutonomous 284
#define T_AdvValidLifetime 285
#define T_AdvPreferredLifetime 286
#define T_AdvRouterAddr 287
#define T_AdvHomeAgentFlag 288
#define T_AdvIntervalOpt 289
#define T_AdvHomeAgentInfo 290
#define T_Base6to4Interface 291
#define T_UnicastOnly 292
#define T_HomeAgentPreference 293
#define T_HomeAgentLifetime 294
#define T_AdvRoutePreference 295
#define T_AdvRouteLifetime 296
#define T_AdvRDNSSPreference 297
#define T_AdvRDNSSOpenFlag 298
#define T_AdvRDNSSLifetime 299
#define T_AdvMobRtrSupportFlag 300
#define T_BAD_TOKEN 301
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   15,   16,    1,   17,   18,   18,    2,    2,
    5,    5,    8,    8,   11,   11,   19,   19,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,    6,    7,    7,    4,    3,   21,   22,   22,
   23,   23,   24,   24,   24,   24,   24,   24,   10,    9,
   25,   26,   26,   27,   27,   28,   28,   13,   12,   31,
   31,   32,   29,   30,   30,   33,   33,   34,   34,   34,
   14,   14,
};
short yylen[] = {                                         2,
    2,    1,    5,    2,    1,    5,    0,    1,    0,    1,
    0,    1,    0,    1,    0,    1,    2,    1,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    5,    2,    3,    2,    5,    4,    0,    1,
    2,    1,    3,    3,    3,    3,    3,    3,    2,    5,
    4,    0,    1,    2,    1,    3,    3,    2,    5,    2,
    1,    1,    2,    0,    1,    2,    1,    3,    3,    3,
    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    2,    0,    5,    4,    1,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   10,    0,   17,   25,   26,   20,   23,   19,   22,
   21,   24,   27,   28,   29,   30,   31,   34,   32,   33,
   35,   38,   36,   37,   41,   39,   40,   42,    3,    0,
    0,    0,   12,   46,    0,    0,    0,    0,    0,    0,
   14,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   52,   48,    0,    0,    0,    0,    6,    0,   16,    0,
   59,    0,    0,    0,   81,   82,    0,    0,    0,    0,
    0,   51,   44,    0,    0,    0,   72,    0,   71,   68,
    0,    0,    0,    0,    0,   65,   53,   54,   56,   57,
   55,   58,   47,   45,   43,   61,   70,    0,    0,    0,
    0,    0,   77,    0,    0,    0,   64,    0,    0,    0,
    0,   76,   66,   67,   60,   78,   79,   80,   69,
};
short yydgoto[] = {                                       2,
    6,   60,   61,   62,   92,   93,  114,   99,  100,  101,
  117,  118,  119,  127,    3,    4,   30,   31,   32,   33,
   63,  109,  110,  111,  102,  144,  145,  146,  120,  161,
  138,  139,  162,  163,
};
short yysindex[] = {                                   -250,
 -227, -250,    0,  -74,    0,    0,    0, -252, -216, -214,
 -259, -232, -231, -213, -212, -208, -206, -205, -204, -203,
 -202, -201, -200, -199, -198, -197, -193, -192, -194,  -64,
 -195, -252,    0,    5,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37, -170, -163,
 -195,    0,  -24,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   53,
  -22, -157,    0,    0, -240, -160, -162, -161, -156, -157,
    0,  -16, -158, -155, -260, -260, -154, -227,  -15, -240,
    0,    0,   50, -125,   66, -153,    0, -156,    0,   -8,
    0, -285,   57,   58,    0,    0,   59,   60,   61,   62,
   63,    0,    0,   64,   65, -138,    0, -153,    0,    0,
 -283, -137, -260,    1, -285,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -135, -136, -260,
    4, -283,    0,   72,   73,   74,    0,   90,   91,   92,
   93,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0, -124,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -116, -120,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -113,
 -116,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -112,    0,    0,   38,    0,    0,    0,   39, -112,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   40,
    0,    0,    0,    0,    0,    0,    0,   39,    0,    0,
    0,   41,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   44,    0,    0,
   43,    0,    0,    0,   45,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   46,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   47,   95,    0,    0,    0,    0,    0,   54,    0,    0,
   42,    0,    0, -104,  151,    0,    0,    0,    0,  125,
    0,    0,    0,   48,    0,    0,    0,   49,    0,    0,
    0,   51,    0,   -3,
};
#define YYTABLESIZE 194
short yytable[] = {                                     135,
    7,  128,  125,   36,    8,   37,    1,  126,    9,  142,
  143,   11,   13,  158,  159,  160,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
   38,   40,   39,   41,    5,   23,   24,   25,  165,   26,
   27,   28,  103,  104,  105,  106,  107,   29,    8,   34,
  108,   35,   42,   43,   44,  170,   45,   46,   47,   48,
   58,   49,   59,   65,   50,   51,   52,   53,   54,   55,
   56,   57,   66,   67,   68,   69,   70,   71,   72,   73,
   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
   84,   85,   86,   87,   88,   89,   90,   91,   95,   96,
   97,   98,  112,  116,  113,  115,  122,  123,  133,  131,
  124,  129,  136,  137,  141,  147,  148,  149,  150,  151,
  152,  153,  154,  155,  156,  166,  164,  168,  171,  169,
  173,  174,  175,    7,    7,    7,    7,    8,    8,    8,
    8,  134,    9,    9,    9,   11,   11,   13,  176,  177,
  178,  179,    7,  121,  130,   94,   64,  132,  172,  140,
    0,    0,   49,   15,   50,   62,   73,   74,    0,   63,
   75,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  157,    0,
    0,    0,    0,  167,
};
short yycheck[] = {                                     125,
  125,  106,  263,  263,  125,  265,  257,  268,  125,  295,
  296,  125,  125,  297,  298,  299,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  263,  263,  265,  265,  262,  288,  289,  290,  143,  292,
  293,  294,  283,  284,  285,  286,  287,  300,  123,  266,
  291,  266,  266,  266,  263,  160,  263,  263,  263,  263,
  125,  264,  258,   59,  266,  266,  266,  266,  266,  263,
  263,  266,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,  267,  261,  123,   47,
  123,  259,  263,  260,  267,  267,  123,  266,   59,  125,
  266,  266,   47,  267,  123,   59,   59,   59,   59,   59,
   59,   59,   59,   59,  263,  125,  264,  263,  125,  266,
   59,   59,   59,  258,  259,  260,  261,  258,  259,  260,
  261,  267,  259,  260,  261,  259,  260,  260,   59,   59,
   59,   59,    2,  100,  108,   61,   32,  110,  162,  118,
   -1,   -1,  125,  125,  125,  125,  123,  125,   -1,  125,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  138,   -1,
   -1,   -1,   -1,  145,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 301
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_INTERFACE",
"T_PREFIX","T_ROUTE","T_RDNSS","T_CLIENTS","STRING","NUMBER","SIGNEDNUMBER",
"DECIMAL","SWITCH","IPV6ADDR","INFINITY","T_IgnoreIfMissing","T_AdvSendAdvert",
"T_MaxRtrAdvInterval","T_MinRtrAdvInterval","T_MinDelayBetweenRAs",
"T_AdvManagedFlag","T_AdvOtherConfigFlag","T_AdvLinkMTU","T_AdvReachableTime",
"T_AdvRetransTimer","T_AdvCurHopLimit","T_AdvDefaultLifetime",
"T_AdvDefaultPreference","T_AdvSourceLLAddress","T_AdvOnLink","T_AdvAutonomous",
"T_AdvValidLifetime","T_AdvPreferredLifetime","T_AdvRouterAddr",
"T_AdvHomeAgentFlag","T_AdvIntervalOpt","T_AdvHomeAgentInfo",
"T_Base6to4Interface","T_UnicastOnly","T_HomeAgentPreference",
"T_HomeAgentLifetime","T_AdvRoutePreference","T_AdvRouteLifetime",
"T_AdvRDNSSPreference","T_AdvRDNSSOpenFlag","T_AdvRDNSSLifetime",
"T_AdvMobRtrSupportFlag","T_BAD_TOKEN",
};
char *yyrule[] = {
"$accept : grammar",
"grammar : grammar ifacedef",
"grammar : ifacedef",
"ifacedef : ifacehead '{' ifaceparams '}' ';'",
"ifacehead : T_INTERFACE name",
"name : STRING",
"ifaceparams : optional_ifacevlist optional_prefixlist optional_clientslist optional_routelist optional_rdnsslist",
"optional_ifacevlist :",
"optional_ifacevlist : ifacevlist",
"optional_prefixlist :",
"optional_prefixlist : prefixlist",
"optional_clientslist :",
"optional_clientslist : clientslist",
"optional_routelist :",
"optional_routelist : routelist",
"optional_rdnsslist :",
"optional_rdnsslist : rdnsslist",
"ifacevlist : ifacevlist ifaceval",
"ifacevlist : ifaceval",
"ifaceval : T_MinRtrAdvInterval NUMBER ';'",
"ifaceval : T_MaxRtrAdvInterval NUMBER ';'",
"ifaceval : T_MinDelayBetweenRAs NUMBER ';'",
"ifaceval : T_MinRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MaxRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MinDelayBetweenRAs DECIMAL ';'",
"ifaceval : T_IgnoreIfMissing SWITCH ';'",
"ifaceval : T_AdvSendAdvert SWITCH ';'",
"ifaceval : T_AdvManagedFlag SWITCH ';'",
"ifaceval : T_AdvOtherConfigFlag SWITCH ';'",
"ifaceval : T_AdvLinkMTU NUMBER ';'",
"ifaceval : T_AdvReachableTime NUMBER ';'",
"ifaceval : T_AdvRetransTimer NUMBER ';'",
"ifaceval : T_AdvDefaultLifetime NUMBER ';'",
"ifaceval : T_AdvDefaultPreference SIGNEDNUMBER ';'",
"ifaceval : T_AdvCurHopLimit NUMBER ';'",
"ifaceval : T_AdvSourceLLAddress SWITCH ';'",
"ifaceval : T_AdvIntervalOpt SWITCH ';'",
"ifaceval : T_AdvHomeAgentInfo SWITCH ';'",
"ifaceval : T_AdvHomeAgentFlag SWITCH ';'",
"ifaceval : T_HomeAgentPreference NUMBER ';'",
"ifaceval : T_HomeAgentLifetime NUMBER ';'",
"ifaceval : T_UnicastOnly SWITCH ';'",
"ifaceval : T_AdvMobRtrSupportFlag SWITCH ';'",
"clientslist : T_CLIENTS '{' v6addrlist '}' ';'",
"v6addrlist : IPV6ADDR ';'",
"v6addrlist : v6addrlist IPV6ADDR ';'",
"prefixlist : prefixdef optional_prefixlist",
"prefixdef : prefixhead '{' optional_prefixplist '}' ';'",
"prefixhead : T_PREFIX IPV6ADDR '/' NUMBER",
"optional_prefixplist :",
"optional_prefixplist : prefixplist",
"prefixplist : prefixplist prefixparms",
"prefixplist : prefixparms",
"prefixparms : T_AdvOnLink SWITCH ';'",
"prefixparms : T_AdvAutonomous SWITCH ';'",
"prefixparms : T_AdvRouterAddr SWITCH ';'",
"prefixparms : T_AdvValidLifetime number_or_infinity ';'",
"prefixparms : T_AdvPreferredLifetime number_or_infinity ';'",
"prefixparms : T_Base6to4Interface name ';'",
"routelist : routedef optional_routelist",
"routedef : routehead '{' optional_routeplist '}' ';'",
"routehead : T_ROUTE IPV6ADDR '/' NUMBER",
"optional_routeplist :",
"optional_routeplist : routeplist",
"routeplist : routeplist routeparms",
"routeplist : routeparms",
"routeparms : T_AdvRoutePreference SIGNEDNUMBER ';'",
"routeparms : T_AdvRouteLifetime number_or_infinity ';'",
"rdnsslist : rdnssdef optional_rdnsslist",
"rdnssdef : rdnsshead '{' optional_rdnssplist '}' ';'",
"rdnssaddrs : rdnssaddrs rdnssaddr",
"rdnssaddrs : rdnssaddr",
"rdnssaddr : IPV6ADDR",
"rdnsshead : T_RDNSS rdnssaddrs",
"optional_rdnssplist :",
"optional_rdnssplist : rdnssplist",
"rdnssplist : rdnssplist rdnssparms",
"rdnssplist : rdnssparms",
"rdnssparms : T_AdvRDNSSPreference NUMBER ';'",
"rdnssparms : T_AdvRDNSSOpenFlag SWITCH ';'",
"rdnssparms : T_AdvRDNSSLifetime number_or_infinity ';'",
"number_or_infinity : NUMBER",
"number_or_infinity : INFINITY",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 676 "gram.y"

static
void cleanup(void)
{
	if (iface)
		free(iface);
	
	if (prefix)
		free(prefix);

	if (route)
		free(route);

	if (rdnss)
		free(rdnss);
}

static void
yyerror(char *msg)
{
	cleanup();
	flog(LOG_ERR, "%s in %s, line %d: %s", msg, conf_file, num_lines, yytext);
}
#line 422 "gram.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 3:
#line 131 "gram.y"
{
			struct Interface *iface2;

			iface2 = IfaceList;
			while (iface2)
			{
				if (!strcmp(iface2->Name, iface->Name))
				{
					flog(LOG_ERR, "duplicate interface "
						"definition for %s", iface->Name);
					ABORT;
				}
				iface2 = iface2->next;
			}			

			if (check_device(sock, iface) < 0) {
				if (iface->IgnoreIfMissing) {
					dlog(LOG_DEBUG, 4, "interface %s did not exist, ignoring the interface", iface->Name);
					goto skip_interface;
				}
				else {
					flog(LOG_ERR, "interface %s does not exist", iface->Name);
					ABORT;
				}
			}
			if (setup_deviceinfo(sock, iface) < 0)
				ABORT;
			if (check_iface(iface) < 0)
				ABORT;
			if (setup_linklocal_addr(sock, iface) < 0)
				ABORT;
			if (setup_allrouters_membership(sock, iface) < 0)
				ABORT;

			iface->next = IfaceList;
			IfaceList = iface;

			dlog(LOG_DEBUG, 4, "interface definition for %s is ok", iface->Name);

skip_interface:
			iface = NULL;
		}
break;
case 4:
#line 175 "gram.y"
{
			iface = malloc(sizeof(struct Interface));

			if (iface == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			iface_init_defaults(iface);
			strncpy(iface->Name, yyvsp[0].str, IFNAMSIZ-1);
			iface->Name[IFNAMSIZ-1] = '\0';
		}
break;
case 5:
#line 190 "gram.y"
{
			/* check vality */
			yyval.str = yyvsp[0].str;
		}
break;
case 6:
#line 197 "gram.y"
{
			iface->AdvPrefixList = yyvsp[-3].pinfo;
			iface->ClientList = yyvsp[-2].ainfo;
			iface->AdvRouteList = yyvsp[-1].rinfo;
			iface->AdvRDNSSList = yyvsp[0].rdnssinfo;
		}
break;
case 9:
#line 210 "gram.y"
{
			yyval.pinfo = NULL;
		}
break;
case 11:
#line 217 "gram.y"
{
			yyval.ainfo = NULL;
		}
break;
case 13:
#line 224 "gram.y"
{
			yyval.rinfo = NULL;
		}
break;
case 15:
#line 231 "gram.y"
{
			yyval.rdnssinfo = NULL;
		}
break;
case 19:
#line 242 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 20:
#line 246 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 21:
#line 250 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].num;
		}
break;
case 22:
#line 254 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 23:
#line 258 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 24:
#line 262 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].dec;
		}
break;
case 25:
#line 266 "gram.y"
{
			iface->IgnoreIfMissing = yyvsp[-1].num;
		}
break;
case 26:
#line 270 "gram.y"
{
			iface->AdvSendAdvert = yyvsp[-1].num;
		}
break;
case 27:
#line 274 "gram.y"
{
			iface->AdvManagedFlag = yyvsp[-1].num;
		}
break;
case 28:
#line 278 "gram.y"
{
			iface->AdvOtherConfigFlag = yyvsp[-1].num;
		}
break;
case 29:
#line 282 "gram.y"
{
			iface->AdvLinkMTU = yyvsp[-1].num;
		}
break;
case 30:
#line 286 "gram.y"
{
			iface->AdvReachableTime = yyvsp[-1].num;
		}
break;
case 31:
#line 290 "gram.y"
{
			iface->AdvRetransTimer = yyvsp[-1].num;
		}
break;
case 32:
#line 294 "gram.y"
{
			iface->AdvDefaultLifetime = yyvsp[-1].num;
		}
break;
case 33:
#line 298 "gram.y"
{
			iface->AdvDefaultPreference = yyvsp[-1].snum;
		}
break;
case 34:
#line 302 "gram.y"
{
			iface->AdvCurHopLimit = yyvsp[-1].num;
		}
break;
case 35:
#line 306 "gram.y"
{
			iface->AdvSourceLLAddress = yyvsp[-1].num;
		}
break;
case 36:
#line 310 "gram.y"
{
			iface->AdvIntervalOpt = yyvsp[-1].num;
		}
break;
case 37:
#line 314 "gram.y"
{
			iface->AdvHomeAgentInfo = yyvsp[-1].num;
		}
break;
case 38:
#line 318 "gram.y"
{
			iface->AdvHomeAgentFlag = yyvsp[-1].num;
		}
break;
case 39:
#line 322 "gram.y"
{
			iface->HomeAgentPreference = yyvsp[-1].num;
		}
break;
case 40:
#line 326 "gram.y"
{
			iface->HomeAgentLifetime = yyvsp[-1].num;
		}
break;
case 41:
#line 330 "gram.y"
{
			iface->UnicastOnly = yyvsp[-1].num;
		}
break;
case 42:
#line 334 "gram.y"
{
			iface->AdvMobRtrSupportFlag = yyvsp[-1].num;
		}
break;
case 43:
#line 340 "gram.y"
{
			yyval.ainfo = yyvsp[-2].ainfo;
		}
break;
case 44:
#line 346 "gram.y"
{
			struct Clients *new = calloc(1, sizeof(struct Clients));
			if (new == NULL) {
				flog(LOG_CRIT, "calloc failed: %s", strerror(errno));
				ABORT;
			}

			memcpy(&(new->Address), yyvsp[-1].addr, sizeof(struct in6_addr));
			yyval.ainfo = new;
		}
break;
case 45:
#line 357 "gram.y"
{
			struct Clients *new = calloc(1, sizeof(struct Clients));
			if (new == NULL) {
				flog(LOG_CRIT, "calloc failed: %s", strerror(errno));
				ABORT;
			}

			memcpy(&(new->Address), yyvsp[-1].addr, sizeof(struct in6_addr));
			new->next = yyvsp[-2].ainfo;
			yyval.ainfo = new;
		}
break;
case 46:
#line 372 "gram.y"
{
			yyvsp[-1].pinfo->next = yyvsp[0].pinfo;
			yyval.pinfo = yyvsp[-1].pinfo;
		}
break;
case 47:
#line 379 "gram.y"
{
			unsigned int dst;

			if (prefix->AdvPreferredLifetime >
			    prefix->AdvValidLifetime)
			{
				flog(LOG_ERR, "AdvValidLifeTime must be "
					"greater than AdvPreferredLifetime in %s, line %d", 
					conf_file, num_lines);
				ABORT;
			}

			if( prefix->if6to4[0] )
			{
				if (get_v4addr(prefix->if6to4, &dst) < 0)
				{
					flog(LOG_ERR, "interface %s has no IPv4 addresses, disabling 6to4 prefix", prefix->if6to4 );
					prefix->enabled = 0;
				} else
				{
					*((uint16_t *)(prefix->Prefix.s6_addr)) = htons(0x2002);
					memcpy( prefix->Prefix.s6_addr + 2, &dst, sizeof( dst ) );
				}
			}

			yyval.pinfo = prefix;
			prefix = NULL;
		}
break;
case 48:
#line 410 "gram.y"
{
			struct in6_addr zeroaddr;
			prefix = malloc(sizeof(struct AdvPrefix));
			
			if (prefix == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			prefix_init_defaults(prefix);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			prefix->PrefixLen = yyvsp[0].num;

			memcpy(&prefix->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));

			memset(&zeroaddr, 0, sizeof(zeroaddr));
			if (!memcmp(yyvsp[-2].addr, &zeroaddr, sizeof(struct in6_addr))) {
#ifndef HAVE_IFADDRS_H
				flog(LOG_ERR, "invalid all-zeros prefix in %s, line %d", conf_file, num_lines);
				ABORT;
#else
				dlog(LOG_DEBUG, 5, "all-zeros prefix in %s, line %d, parsing..", conf_file, num_lines);
				struct ifaddrs *ifap, *ifa;
				if (getifaddrs(&ifap) != 0)
					flog(LOG_ERR, "getifaddrs failed: %s", strerror(errno));
			        for (ifa = ifap; ifa; ifa = ifa->ifa_next) {
				        struct sockaddr_in6 *s6;
					char buf[INET6_ADDRSTRLEN];
					if (strncmp(ifa->ifa_name, iface->Name, IFNAMSIZ))
						continue;
                			if (ifa->ifa_addr->sa_family != AF_INET6)
			                        continue;
					s6 = (struct sockaddr_in6 *)(ifa->ifa_addr);
	                		if (IN6_IS_ADDR_LINKLOCAL(&s6->sin6_addr))
						continue;
					if (inet_ntop(ifa->ifa_addr->sa_family, (void *)&(s6->sin6_addr), buf, sizeof(buf)) == NULL) {
						flog(LOG_ERR, "%s: inet_ntop failed in %s, line %d!", ifa->ifa_name, conf_file, num_lines);
					}
					else {
						dlog(LOG_DEBUG, 5, "auto-selected prefix %s on interface %s", buf, ifa->ifa_name);
						memcpy(&prefix->Prefix, &s6->sin6_addr, sizeof(struct in6_addr));
						prefix->AdvRouterAddr=1;
						prefix->AutoSelected=1;
					}
				}
				if (!memcmp(&prefix->Prefix, &zeroaddr, sizeof(struct in6_addr))) {
					prefix->enabled = 0;
					flog(LOG_WARNING, "no auto-selected prefix on interface %s, disabling advertisements",  iface->Name);
				}
				freeifaddrs(ifap);
				freeifaddrs(ifa);
#endif /* ifndef HAVE_IFADDRS_H */
			}
		}
break;
case 53:
#line 481 "gram.y"
{
			prefix->AdvOnLinkFlag = yyvsp[-1].num;
		}
break;
case 54:
#line 485 "gram.y"
{
			prefix->AdvAutonomousFlag = yyvsp[-1].num;
		}
break;
case 55:
#line 489 "gram.y"
{
			if (prefix->AutoSelected && yyvsp[-1].num == 0)
				flog(LOG_WARNING, "prefix automatically selected, AdvRouterAddr always enabled, ignoring config line %d", num_lines);
			else  
				prefix->AdvRouterAddr = yyvsp[-1].num;
		}
break;
case 56:
#line 496 "gram.y"
{
			prefix->AdvValidLifetime = yyvsp[-1].num;
		}
break;
case 57:
#line 500 "gram.y"
{
			prefix->AdvPreferredLifetime = yyvsp[-1].num;
		}
break;
case 58:
#line 504 "gram.y"
{
			if (prefix->AutoSelected) {
				flog(LOG_ERR, "automatically selecting the prefix and Base6to4Interface are mutually exclusive");
				ABORT;
			} /* fallthrough */
			dlog(LOG_DEBUG, 4, "using interface %s for 6to4", yyvsp[-1].str);
			strncpy(prefix->if6to4, yyvsp[-1].str, IFNAMSIZ-1);
			prefix->if6to4[IFNAMSIZ-1] = '\0';
		}
break;
case 59:
#line 516 "gram.y"
{
			yyvsp[-1].rinfo->next = yyvsp[0].rinfo;
			yyval.rinfo = yyvsp[-1].rinfo;
		}
break;
case 60:
#line 523 "gram.y"
{
			yyval.rinfo = route;
			route = NULL;
		}
break;
case 61:
#line 531 "gram.y"
{
			route = malloc(sizeof(struct AdvRoute));
			
			if (route == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			route_init_defaults(route, iface);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid route prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			route->PrefixLen = yyvsp[0].num;

			memcpy(&route->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));
		}
break;
case 66:
#line 564 "gram.y"
{
			route->AdvRoutePreference = yyvsp[-1].snum;
		}
break;
case 67:
#line 568 "gram.y"
{
			route->AdvRouteLifetime = yyvsp[-1].num;
		}
break;
case 68:
#line 574 "gram.y"
{
			yyvsp[-1].rdnssinfo->next = yyvsp[0].rdnssinfo;
			yyval.rdnssinfo = yyvsp[-1].rdnssinfo;
		}
break;
case 69:
#line 581 "gram.y"
{
			yyval.rdnssinfo = rdnss;
			rdnss = NULL;
		}
break;
case 72:
#line 592 "gram.y"
{
			if (!rdnss) {
				/* first IP found */
				rdnss = malloc(sizeof(struct AdvRDNSS));
				
				if (rdnss == NULL) {
					flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
					ABORT;
				}

				rdnss_init_defaults(rdnss, iface);
			}
			
			switch (rdnss->AdvRDNSSNumber) {
				case 0:
					memcpy(&rdnss->AdvRDNSSAddr1, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				case 1:
					memcpy(&rdnss->AdvRDNSSAddr2, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				case 2:
					memcpy(&rdnss->AdvRDNSSAddr3, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				default:
					flog(LOG_CRIT, "Too many addresses in RDNSS section");
					ABORT;
			}
			
		}
break;
case 73:
#line 627 "gram.y"
{
			if (!rdnss) {
				flog(LOG_CRIT, "No address specified in RDNSS section");
				ABORT;
			}
		}
break;
case 78:
#line 645 "gram.y"
{
			rdnss->AdvRDNSSPreference = yyvsp[-1].num;
		}
break;
case 79:
#line 649 "gram.y"
{
			rdnss->AdvRDNSSOpenFlag = yyvsp[-1].num;
		}
break;
case 80:
#line 653 "gram.y"
{
			if (yyvsp[-1].num < iface->MaxRtrAdvInterval && yyvsp[-1].num != 0) {
				flog(LOG_ERR, "AdvRDNSSLifetime must be at least MaxRtrAdvInterval");
				ABORT;
			}
			if (yyvsp[-1].num > 2*(iface->MaxRtrAdvInterval))
				flog(LOG_WARNING, "Warning: AdvRDNSSLifetime <= 2*MaxRtrAdvInterval would allow stale DNS servers to be deleted faster");

			rdnss->AdvRDNSSLifetime = yyvsp[-1].num;
		}
break;
case 81:
#line 666 "gram.y"
{
                                yyval.num = yyvsp[0].num; 
                        }
break;
case 82:
#line 670 "gram.y"
{
                                yyval.num = (uint32_t)~0;
                        }
break;
#line 1170 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
